jif.types

## Class ConstArrayType_c

- java.lang.Object
- - polyglot.types.TypeObject_c
  - - polyglot.types.Type_c
    - - polyglot.types.ReferenceType_c
      - - polyglot.types.ArrayType_c
        - - jif.types.ConstArrayType_c

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, ConstArrayType, polyglot.types.ArrayType, polyglot.types.Qualifier, polyglot.types.ReferenceType, polyglot.types.Type, polyglot.types.TypeObject, polyglot.util.Copy<polyglot.types.TypeObject>

      public class ConstArrayType_c
      extends polyglot.types.ArrayType_c
      implements ConstArrayType

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface polyglot.util.Copy

      `polyglot.util.Copy.Util`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `isConst`
    `protected boolean` | `isNonConst`

    - ### Fields inherited from class polyglot.types.ArrayType_c

      `base, fields, interfaces, methods`

    - ### Fields inherited from class polyglot.types.TypeObject_c

      `position, ts`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ConstArrayType_c()` Used for deserializing types.
    `` | `ConstArrayType_c(JifTypeSystem ts, polyglot.util.Position pos, polyglot.types.Type base, boolean isConst)`
    `` | `ConstArrayType_c(JifTypeSystem ts, polyglot.util.Position pos, polyglot.types.Type base, boolean isConst, boolean isNonConst)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equalsImpl(polyglot.types.TypeObject o)`
    `protected void` | `init()`
    `boolean` | `isConst()` The array type is a const array (or castable to one).
    `boolean` | `isImplicitCastValidImpl(polyglot.types.Type toType)`
    `boolean` | `isNonConst()` The array type is a non-const array (or castable to one).
    `java.lang.String` | `toString()`

    - ### Methods inherited from class polyglot.types.ArrayType_c

      `base, base, cloneMethod, createCloneMethodInstance, createLengthFieldInstance, dims, fieldNamed, fields, hashCode, interfaces, isArray, isCanonical, isCastValidImpl, lengthField, methods, print, superType, toArray, translate, typeEqualsImpl, ultimateBase`

    - ### Methods inherited from class polyglot.types.ReferenceType_c

      `descendsFromImpl, hasMethod, hasMethodImpl, isReference, members, methods, methodsNamed, toReference`

    - ### Methods inherited from class polyglot.types.Type_c

      `arrayOf, arrayOf, descendsFrom, isBoolean, isByte, isCastValid, isChar, isClass, isComparable, isDouble, isFloat, isImplicitCastValid, isInt, isIntOrLess, isLong, isLongOrLess, isNull, isNumeric, isPackage, isPrimitive, isShort, isSubtype, isSubtypeImpl, isThrowable, isType, isUncheckedException, isVoid, numericConversionValid, numericConversionValid, numericConversionValidImpl, numericConversionValidImpl, toClass, toNull, toPackage, toPrimitive, toType, typeEquals`

    - ### Methods inherited from class polyglot.types.TypeObject_c

      `copy, equals, position, typeSystem`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface polyglot.types.ArrayType

      `base, base, cloneMethod, dims, lengthField, ultimateBase`

    - ### Methods inherited from interface polyglot.types.ReferenceType

      `fieldNamed, fields, hasMethod, hasMethodImpl, interfaces, members, methods, methods, methodsNamed, superType`

    - ### Methods inherited from interface polyglot.types.Type

      `arrayOf, arrayOf, descendsFrom, descendsFromImpl, isArray, isBoolean, isByte, isCastValid, isCastValidImpl, isChar, isClass, isComparable, isDouble, isFloat, isImplicitCastValid, isInt, isIntOrLess, isLong, isLongOrLess, isNull, isNumeric, isPrimitive, isReference, isShort, isSubtype, isSubtypeImpl, isThrowable, isUncheckedException, isVoid, numericConversionValid, numericConversionValid, numericConversionValidImpl, numericConversionValidImpl, print, toArray, toClass, toNull, toPrimitive, toReference, translate, typeEquals, typeEqualsImpl`

    - ### Methods inherited from interface polyglot.types.Qualifier

      `isPackage, isType, toPackage, toType`

    - ### Methods inherited from interface polyglot.types.TypeObject

      `isCanonical, position, typeSystem`

    - ### Methods inherited from interface polyglot.util.Copy

      `copy`

- - ### Field Detail

    - #### isConst

          protected boolean isConst

    - #### isNonConst

          protected boolean isNonConst

  - ### Constructor Detail

    - #### ConstArrayType_c

          protected ConstArrayType_c()

      Used for deserializing types.

    - #### ConstArrayType_c

          public ConstArrayType_c(JifTypeSystem ts,
                                  polyglot.util.Position pos,
                                  polyglot.types.Type base,
                                  boolean isConst)

    - #### ConstArrayType_c

          public ConstArrayType_c(JifTypeSystem ts,
                                  polyglot.util.Position pos,
                                  polyglot.types.Type base,
                                  boolean isConst,
                                  boolean isNonConst)

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `polyglot.types.Type`
      Overrides:
        `toString` in class `polyglot.types.ArrayType_c`

    - #### equalsImpl

          public boolean equalsImpl(polyglot.types.TypeObject o)

      Specified by:
        `equalsImpl` in interface `polyglot.types.TypeObject`
      Overrides:
        `equalsImpl` in class `polyglot.types.ArrayType_c`

    - #### isConst

          public boolean isConst()

      Description copied from interface: `ConstArrayType`
      The array type is a const array (or castable to one).
      Specified by:
        `isConst` in interface `ConstArrayType`

    - #### isNonConst

          public boolean isNonConst()

      Description copied from interface: `ConstArrayType`
      The array type is a non-const array (or castable to one).
      Specified by:
        `isNonConst` in interface `ConstArrayType`

    - #### isImplicitCastValidImpl

          public boolean isImplicitCastValidImpl(polyglot.types.Type toType)

      Specified by:
        `isImplicitCastValidImpl` in interface `polyglot.types.Type`
      Overrides:
        `isImplicitCastValidImpl` in class `polyglot.types.ArrayType_c`

    - #### init

          protected void init()

      Overrides:
        `init` in class `polyglot.types.ArrayType_c`